/* GCC */
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

struct point{
    int x, y, n;
};

bool cmp(point x, point y){
    return (x.x < y.x || (x.x == y.x && x.y < y.y));
}

bool cw(point q, point w, point e){
    int x1 = w.x - q.x;
    int x2 = e.x - w.x;
    int y1 = w.y - q.y;
    int y2 = e.y - w.y;
    return (x1*y2 - x2*y1 <= 0);

}

bool line(point q, point w, point e){
    int x1 = w.x - q.x;
    int x2 = e.x - w.x;
    int y1 = w.y - q.y;
    int y2 = e.y - w.y;
    return (x1*y2 - x2*y1 == 0);

}

int main(){
    freopen("polyline.in", "r", stdin);
    freopen("polyline.out", "w", stdout);
    int n;
    scanf("%d", &n);
    vector<point> A(n);
    for(int i = 0; i < n; i++) { scanf("%d%d", &A[i].x, &A[i].y); A[i].n = i+1; }
    fclose(stdin);
    sort(A.begin(), A.end(), &cmp);

    //for(int i = 0; i < n; i++) printf("%d\n", A[i].n);
    vector<point> OG; OG.assign(1, A[0]);
    vector<bool> V(n, true);
    for(int i = 1; i < n; i++){
        while(OG.size() >= 2 && !cw(OG[OG.size()-2], OG.back(), A[i])) OG.erase(OG.end()-1);
        OG.push_back(A[i]);
    }
    if( OG.size() == n && line(OG.front(), OG[1], OG.back())) { printf("0\n"); fclose(stdout); return 0; }
    for(int i = 0; i < OG.size(); i++) V[OG[i].n] = false;
    for(int i = n-1; i > -1; i--) if(V[A[i].n]) OG.push_back(A[i]);
    for(int i = 0; i < n-1; i++) printf("%d ", OG[i].n); printf("%d\n", OG.back().n);

    fclose(stdout);
    return 0;
}
