/* GCC */

#include <cstdio>
#include <vector>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <climits>
#include <stdint.h>

using namespace std;

typedef uint64_t u64;

int m, l;
vector<u64> bad_numbers;
vector<u64> dp[2][10];
u64 costs[61][10];
vector<int> adj[10];

#define all(container) (container).begin(), (container).end()

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("caves.in");
    ofstream fout("caves.out");

    fin >> m >> l;
    for (int i = 0; i < 10; ++i) {
        for (int j=0; j < 10; ++j) {
            int t;
            fin >> t;
            if (t)
                adj[i].push_back(j);
        }
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 10; ++j) {
            fin >> costs[i][j];
        }
    }

    while (1) {
        u64 t;
        fin >> t;
        if (!fin)
            break;
        bad_numbers.push_back(t);
    }
    l = bad_numbers.size();

    int now = 1, prev = 0;
    for (int i = 0; i < 10; ++i) {
        dp[now][i].push_back(costs[0][i]);
    }

    for (int i = 1; i <= m; ++i) {
        now ^= 1;
        prev ^= 1;
        if (i == m) {
            adj[0].resize(10);
            adj[0][0] = 0;
            for (int j = 1; j < 10; ++j) {
                adj[j].resize(1);
                adj[0][j] = j;
                adj[j][0] = 0;
            }

        }
        for (int j = 0; j < 10; ++j)
            dp[now][j].resize(0);

        for (int cave = 0; cave < 10; ++cave) {
            static u64 temp[(int)1e6+1];

            for (int j = 0; j < adj[cave].size(); ++j) {
                int fromCave = adj[cave][j];

                for (int k = 0; k < dp[prev][fromCave].size(); ++k) {
                    dp[prev][fromCave][k] += costs[i][cave];
                }

                u64* end_ = set_union(all(dp[now][cave]), all(dp[prev][fromCave]), temp);
                dp[now][cave].resize(end_ - temp);
                copy(temp, end_, dp[now][cave].begin());

                for (int k = 0; k < dp[prev][fromCave].size(); ++k) {
                    dp[prev][fromCave][k] -= costs[i][cave];
                }
            }
        }

    }
    reverse(bad_numbers.begin(), bad_numbers.end());

    int j = 0;
    int kount = 0;
    u64 mn = ULLONG_MAX;
    u64 mx = 0;

    for (int i = 0; i < dp[now][0].size(); ++i) {
        while (j < l && bad_numbers[j] < dp[now][0][i])
            ++j;
        if (j < l && bad_numbers[j] == dp[now][0][i])
            continue;
        ++kount;
        mn = min(mn, dp[now][0][i]);
        mx = max(mx, dp[now][0][i]);
    }

    fout << kount << " " << mx << " " << mn << "\n";

    return 0;
}
