/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;
typedef long long ll;

struct point {
    point(int _x, int _y, int _idx)
    :x(_x), y(_y), idx(_idx)
    {}

    int x;
    int y;
    int idx;
};


vector <point> pts[20001];
bool used[2018] = {};

inline bool clockwise(const point &p1, const point &p2, const point &p3) {
    return ((ll)(p2.y - p1.y) * (ll)(p3.x - p1.x)) >= ((ll)(p3.y - p1.y) * (ll)(p2.x - p1.x));
}

inline bool zero(const point &p1, const point &p2, const point &p3) {
    return ((ll)(p2.y - p1.y) * (ll)(p3.x - p1.x)) == ((ll)(p3.y - p1.y) * (ll)(p2.x - p1.x));
}

inline bool point_comp(const point &p1, const point &p2) {
    return p1.y < p2.y;
}

int main() {
    freopen("polyline.in", "r", stdin);
    freopen("polyline.out", "w", stdout);
    int n, X, Y, xmin(300000), xmax(-300000);
    //cin >> n;
    scanf("%d", &n);
    for(int i = 1; i <= n; i++) {
        //cin >> X >> Y;
        scanf("%d%d", &X, &Y);
        X += 10000;
        if(X <= xmin)
            xmin = X;
        if(X > xmax)
            xmax = X;

        pts[X].push_back(point(X, Y, i));
    }

    if(xmin == xmax) {
        //cout << "0\n";
        printf("0\n");
        return 0;
    }

    vector <point> ch;
    bool a_zero = true, clock;

    for(int x = xmin; x <= xmax; x++)
        if(!pts[x].empty()) {
            sort(pts[x].begin(), pts[x].end(), point_comp);
            while(ch.size() > 1 && !clockwise(ch[ch.size() - 2], ch.back(), pts[x].back())) {
                ch.pop_back();
                a_zero = false;
            }

            if(a_zero && ch.size() > 1)
                a_zero &= zero(ch[ch.size() - 2], ch.back(), pts[x].back());
            ch.push_back(pts[x].back());
        }


    if(ch.size() == n && a_zero) {
        printf("0\n");
        return 0;
    }

    for(int i = 0; i < ch.size(); i++)
        used[ch[i].idx] = true;

    for(int i = pts[xmax].size() - 2; i >= 0; i--)
        ch.push_back(pts[xmax][i]);

    for(int x = xmax - 1; x >= xmin; x--)
        for(int i = 0; i < pts[x].size(); i++)
            if(!used[pts[x][i].idx])
                ch.push_back(pts[x][i]);

    for(int i = 0; i < ch.size() - 1; i++)
        printf("%d ", ch[i].idx);
    printf("%d\n", ch[ch.size() - 1].idx);
}
