/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;

const int MAX=2018;

struct pt
{
    int x, y, id;
    pt () {}
    pt (int a, int b): x(a), y(b) {}
    bool operator < (pt p)
    {
        return x<p.x||(x==p.x&&y<p.y);
    }
};

int area(pt a, pt b, pt c)
{
    return (b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y);
}

int d(pt u, pt v)
{
    return (u.x-v.x)*(u.x-v.x)+(u.y-v.y)*(u.y-v.y);
}

struct cmp
{
    pt p;
    cmp(pt t): p(t) {}
    bool operator () (pt u, pt v) const
    {
        if(area(p, u, v)==0) return d(u, p)<d(v, p);
        return area(p, u, v)<0;
    }
};

int n;
pt arr[MAX];

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("polyline.in");
    ofstream cout("polyline.out");
    cin >> n;
    for(int i=0; i<n; ++i)
        cin >> arr[i].x >> arr[i].y, arr[i].id=i+1;
    int zero=0;
    for(int i=1; i<n; ++i)
    {
        if(arr[i]<arr[zero])
            zero=i;
    }
    swap(arr[0], arr[zero]);
    sort(arr+1, arr+n, cmp(arr[0]));
    int pnt=n-1;
    while(pnt>0&&area(arr[0], arr[pnt-1], arr[pnt])==0)
        --pnt;
    if(pnt==0) cout << "0\n";
    else
    {
        reverse(arr+pnt, arr+n);
        for(int i=0; i<n; ++i)
        {
            cout << arr[i].id;
            if(i!=n-1) cout << ' ';
        }
        cout << endl;
    }
    return 0;
}
