/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>
#include <iterator>

using namespace std;

struct point
{
    point(int _x, int _y, int _idx)
        : x(_x), y(_y), idx(_idx)
    {}
    int x;
    int y;
    int idx;
};

int n, x, y, xmin(1000000), xmax(-1000000);
vector<point> pts[20001];
bool used[2018] = {};

bool operator<(const point& p1, const point& p2)
{
    return p1.y < p2.y;
}

bool clockwise(const point& p1, const point& p2, const point& p3)
{
    return (p2.y - p1.y)*(p3.x - p1.x) >= (p3.y - p1.y)*(p2.x - p1.x);
}

bool zero(const point& p1, const point& p2, const point& p3)
{
    return (p2.y - p1.y)*(p3.x - p1.x) == (p3.y - p1.y)*(p2.x - p1.x);
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("polyline.in");
    in >> n;
    for(int i = 1; i <= n; ++i)
    {
        in >> x >> y;
        x += 10000;
        pts[x].push_back(point(x, y, i));
        if(x < xmin)
            xmin = x;
        if(x > xmax)
            xmax = x;
    }
    in.close();
    if(xmin == xmax)
    {
        ofstream out("polyline.out");
        out << "0\n";
        out.close();
        return 0;
    }
    vector<point> ans;
    sort(pts[xmin].begin(), pts[xmin].end());
    copy(pts[xmin].begin(), pts[xmin].end(), back_inserter(ans));
    bool ans_zero = true;
    if(pts[xmin].size() > 1)
        ans_zero = false;
    for(x = xmin + 1; x <= xmax; ++x)
        if(!pts[x].empty())
        {
            sort(pts[x].begin(), pts[x].end());
            while(ans.size() > 1 && !clockwise(ans[ans.size() - 2], ans.back(), pts[x].back()))
            {
                ans_zero = false;
                ans.pop_back();
            }
            if(ans_zero && ans.size() > 1)
                ans_zero &= zero(ans[ans.size() - 2], ans.back(), pts[x].back());
            ans.push_back(pts[x].back());
        }
    if(ans_zero && ans.size() == n)
    {
        ofstream out("polyline.out");
        out << "0\n";
        out.close();
        return 0;
    }
    for(int i = 0; i < ans.size(); ++i)
        used[ans[i].idx] = true;
    for(int i = pts[xmax].size() - 2; i >= 0; --i)
        ans.push_back(pts[xmax][i]);
    for(int x = xmax - 1; x > xmin; --x)
        for(int i = 0; i < pts[x].size(); ++i)
            if(!used[pts[x][i].idx])
                ans.push_back(pts[x][i]);
    ofstream out("polyline.out");
    for(int i = 0; i < ans.size(); ++i)
        out << ans[i].idx << (i == ans.size() - 1 ? '\n' : ' ');
    out.close();
    return 0;
}
